/*
    Fichier filtredest.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence.fr

    Traductions des droits d'utilisation dans les fichiers :
    licence.de , licence.en , licence.es , licence.it
    licence.nl , licence.pt , licence.eo , licence.eo-utf


    Ce programme dtruit les fichiers mail envoys  des
    destinataires particuliers.
    Il sert  filtrer les spams envoys  une adresse Email
    alphabtiquement voisines de l'adresse de celui qui reoit
    le mail.

    La liste des adresses de destinataires interdites est mmorise
    dans un fichier

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include "buflect.h"
#include "pop.h"
#include "testchamp.h"
#include "trtentete.h"


#define nbmax_dest    500     // nombre max de destinataires interdits


/* prototypes */
int testdest (int numes);


/* variables globales au source
   (pour viter des tonnes de passages de paramtres) */

char *listedest [nbmax_dest]; // mmorise les destinataires interdits
int  sz_listedest;     // nombre de destinataires mmoriss dans listedest
char bufTo [80];       // buffer contenant le destinataire du mail
FILE *ftrace;          // Fichier contenant les destinataires des mail refuss
char datecour [10];    // Date courante (pour le fichier des mails refuss)


/* programme principal */

int main (int nbarg, char *varg[])
{
    char ficonf [80];    // fichier de configuration du systme de mail
    FILE *fconf;         // descripteur du fichier de configuration
    char fichliste [90]; // fichier contenant la liste des chaines  tester
    int  numes, nbmes;   // mumro du mail courant et nombre de mails
    char bufw [80];      // buffer d'envoi d'une requte de destruction de mail
    int  conserves = 0;  // nombre de mails conservs
    int  supprimes = 0;  // nombre de mails supprims
    char *ncom;          // nom de la commande que l'on excute (filtredest)


    // rcupration du nom de l'excutable
    ncom = varg [0];
    nbarg --;
    varg ++;

    // si le programme a t lanc avec l'option -t
    if (nbarg == 3 && strcmp (*varg, "-t") == 0)
    {
        // ouvrir le fichier trace en criture fin de fichier
        ftrace = fopen (varg [1], "a");

        // si nom de fichier correct
        if (ftrace)
            // initialiser la date courante
            initdatecour (datecour);
        else
            // sinon, avertir l'utilisateur
            fprintf (stderr, "Impossible d'crire dans le fichier %s\n",
                                                               varg [1]);

        // sauter les arguments traits
        nbarg -= 2;
        varg += 2;
    }
    // sinon, pas d'utilisation d'un fichier trace
    else
        ftrace = NULL;

    // controle du nombre d'arguments restants
    if (nbarg == 1)
    {
        // rcuprer le nom du fichier de configuration
        strcpy (ficonf, *varg);

        if (ficonf [strlen (ficonf) - 4] != '.')
            strcat (ficonf, ".cfg");

        // ouvrir le fichier de configuration
        fconf = fopen (ficonf, "r");

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // chercher le nom du fichier contenant les destinataires interdits
                fgets (fichliste, sizeof (fichliste), fconf);
                strcpy (fichliste + strlen (fichliste) - 1, "/refus_dest");

                // charger en mmoire les destinataires interdits
                sz_listedest = charge_valchamp (fichliste, listedest,
                                                nbmax_dest, "nbmax_dest");

                // si la liste n'est pas vide
                if (sz_listedest)
                {
                    // rcupration du nombre de mails
                    nbmes = nbmails ();

                    // vrification des diffrents mails
                    for (numes = 1; numes <= nbmes; numes++)
                    {
                        // si le destinataire du mail contient une chaine interdite
                        if (testdest (numes))
                        {
                            // demande de destruction du mail
                            sprintf (bufw, "DELE %d", numes);
                            env_pop (bufw);
                            lire_pop ();
                            supprimes ++;

                            // si utilisation d'un fichier trace
                            if (ftrace)
                                // mmoriser le destinataire de ce mail
                                fprintf (ftrace, "%s%s\n", datecour, bufTo);
                        }
                        else
                            conserves ++;
                    }

                    // dition d'un rcapitulatif
                    printf ("\n%d messages conservs, %d supprims\n",
                                              conserves, supprimes);
                }

                // se dconnecter proprement du serveur pop
                deconnect_pop ();

                // si des mails ont t supprims
                if (supprimes)
                    // attendre pour enregistrement correct des suppressions
                    // (vite problme si autre filtre appel juste aprs)
                    sleep (2);
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
        else
            fprintf (stderr, "Fichier %s non trouv\n", ficonf);
    }
    else
fprintf (stderr, "Syntaxe : %s [-t fichier_trace] fich_configuration\n", ncom);

    return (0);
}



/* lit l'entte d'un mail et vrifie si son destinataire est autoris */

int testdest (int numes)
{
    char bufw [80];       // buffer d'envoi d'une requte
    int  i;               // simple compteur


    printf ("\rMessage %d", numes);
    fflush (stdout);

    // initialisation
    bufTo [0] = '\0';

    // demande de lecture de l'entte du message
    sprintf (bufw, "TOP %d 1", numes);
    env_pop (bufw);

    // lecture entte du message et mmorisation du destinataire du mail
    do
    {
        // lire une ligne de l'entte du message
        lire_pop ();

        // si on a trouv le champ destinataire
        if (start ("To"))
        {
            // convertir les caractres spciaux de la ligne
            majlignentete ();

            // initialisation
            i = 3;

            // recherche du dbut du destinataire
            while (buf_lect [i] == ' ')
                i++;

            // tronquer si ncessaire le destinataire (pour viter un plantage)
            if (strlen (buf_lect + i) > sizeof (bufTo))
                 buf_lect [i + sizeof (bufTo) - 1] = '\0';

            // mmorisation du destinataire
            strcpy (bufTo, buf_lect + i);
        }
    }
    // lecture termine si ligne limite  un .
    while (buf_lect [0] != '.' || buf_lect [1] != '\0');

    // vrifier si le mail contient un des destinataire de la liste interdite
    return trouve_valchamp (bufTo, listedest, sz_listedest);
}
